> ## Documentation Index
> Fetch the complete documentation index at: https://www.commercengine.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List all saved cards

> Retrieve a list of saved payment cards for a given customer.



## OpenAPI

````yaml get /customers/{customer_id}/cards
openapi: 3.1.0
info:
  version: '1.0'
  title: CE Storefront APIs
  summary: Customer-facing e-commerce API for building exceptional shopping experiences
  description: >-
    Public-facing API for Commerce Engine storefronts, enabling seamless
    shopping experiences with product browsing, cart management, checkout
    processing, user accounts, and order tracking. Perfect for building web,
    mobile, and headless commerce applications.
  contact:
    name: Support
    email: support@commercengine.io
    url: https://www.commercengine.io/contact-us
  license:
    url: https://www.commercengine.io/contact-us
    name: All Rights Reserved
servers:
  - url: https://staging.api.commercengine.io/api/v1/{store_id}/storefront
    description: Staging Server
    variables:
      store_id:
        description: Store ID
        default: store_id
    x-speakeasy-server-id: staging
  - url: https://prod.api.commercengine.io/api/v1/{store_id}/storefront
    description: Prod Server
    variables:
      store_id:
        description: Store ID
        default: store_id
    x-speakeasy-server-id: prod
security: []
tags:
  - name: Analytics
    description: Analytics
  - name: Auth
    description: auth
  - name: Campaigns
    description: Campaigns
  - name: Carts
    description: Carts
  - name: Catalog
    description: Catalog
  - name: Common
    description: Common
  - name: Coupons & promotions
    description: Coupons & promotions
  - name: Customers
    description: Customers
  - name: Juspay
    description: Juspay Payments
  - name: KYC
    description: KYC
  - name: Marketplace
    description: Marketplace
  - name: Orders
    description: Orders
  - name: Others
    description: Others
  - name: Payments
    description: Payments
  - name: PayU
    description: PayU Payments
  - name: POS
    description: POS
  - name: Shipping
    description: Shipping
  - name: Store
    description: Store
  - name: Subscriptions
    description: Subscriptions
externalDocs:
  url: https://llm-docs.commercengine.io
  description: Commerce Engine API Reference Documentation
paths:
  /customers/{customer_id}/cards:
    parameters:
      - name: customer_id
        in: path
        description: Customer Id
        required: true
        schema:
          type: string
    get:
      tags:
        - Customers
      summary: List all saved cards
      description: Retrieve a list of saved payment cards for a given customer.
      operationId: list-customer-cards
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                required:
                  - message
                  - success
                  - content
                properties:
                  message:
                    type: string
                  success:
                    type: boolean
                  content:
                    properties:
                      cards:
                        type: array
                        items:
                          $ref: '#/components/schemas/JuspayCardDetail'
                    required:
                      - cards
                    type: object
          links:
            CreateOrderWithSavedCard:
              operationId: create-order
              description: >-
                Create an order using a saved card. Use `card_token` from a
                `JuspayCardDetail` as part of a `JusPaySavedCardToken` payment
                method payload.
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
      security:
        - Authorization: []
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/operations/list-customer-cards
        description: API reference for the list-customer-cards operation
components:
  schemas:
    JuspayCardDetail:
      title: JuspayCardDetail
      type: object
      externalDocs:
        url: https://llm-docs.commercengine.io/storefront/schemas/JuspayCardDetail
        description: API reference for the JuspayCardDetail schema
      required:
        - card_sub_type
        - extended_card_type
        - nickname
        - provider_category
        - vault_provider
        - card_reference
        - card_type
        - metadata
        - card_issuer
        - card_token
        - health
        - card_exp_month
        - mandate_support
        - provider
        - card_sub_type_category
        - expired
        - card_fingerprint
        - tokenize_support
        - juspay_bank_code
        - card_exp_year
        - name_on_card
        - country_code
        - card_number
        - card_isin
        - card_brand
        - card_issuer_country
      properties:
        card_sub_type:
          type: string
        token:
          type: object
          additionalProperties: true
          properties:
            tokenization_status:
              type: string
            support_token_transaction:
              type: boolean
            last_four_digits:
              type: string
            cvv_less_support:
              type: boolean
            vault_provider:
              type: string
            par:
              type: string
            card_reference:
              type: string
            expiry_month:
              type: string
            token_supported_gateways:
              type: array
              items:
                type: string
            card_fingerprint:
              type: string
            cvv_less_details:
              type: array
              items:
                type: object
                additionalProperties: true
                properties:
                  gateway:
                    type: string
                  gateway_reference_ids:
                    type: array
                    items:
                      type: string
            cvv_less_supported_gateways:
              type: array
              items:
                type: string
            provision_token_id:
              type: string
            card_isin:
              type: string
            expiry_year:
              type: string
        extended_card_type:
          type: string
        tokens:
          type: array
          items:
            type: object
            additionalProperties: true
            properties:
              tokenization_status:
                type: string
              last_four_digits:
                type: string
              provider_category:
                type: string
              vault_provider:
                type: string
              par:
                type: string
              card_reference:
                type: string
              card_token:
                type: string
              expiry_month:
                type: string
              card_fingerprint:
                type: string
              provision_token_id:
                type: string
              card_isin:
                type: string
              expiry_year:
                type: string
        nickname:
          type: string
        provider_category:
          type: string
        vault_provider:
          type: string
        card_reference:
          type: string
        card_type:
          type: string
        metadata:
          type: object
          additionalProperties: true
          properties:
            origin_customer_id:
              type: string
            origin_merchant_id:
              type: string
        card_issuer:
          type: string
        card_token:
          type: string
        health:
          type: string
        card_exp_month:
          type: string
        mandate_support:
          type: boolean
        provider:
          type: string
        card_sub_type_category:
          type: string
        expired:
          type: boolean
        card_fingerprint:
          type: string
        tokenize_support:
          type: boolean
        juspay_bank_code:
          type: string
        card_exp_year:
          type: string
        name_on_card:
          type: string
        country_code:
          type: string
        atm_pin_auth_support:
          type: boolean
        direct_otp_support:
          type: boolean
        card_number:
          type: string
        card_isin:
          type: string
        card_brand:
          type: string
        card_issuer_country:
          type: string
      additionalProperties: true
      examples: []
  responses:
    Unauthorized:
      description: Not authorized for given operation on the Resource
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                examples:
                  - Not authorized for given operation on the Resource.
                x-speakeasy-error-message: true
              success:
                type: boolean
                default: false
              code:
                type: string
                examples:
                  - unauthorized
    NotFound:
      description: Requested resource not found
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                x-speakeasy-error-message: true
              success:
                type: boolean
              code:
                type: string
  securitySchemes:
    Authorization:
      type: http
      description: Access token
      scheme: bearer

````